$path = "$appPathBC260\$dvdNameBC260\Applications\"
$AllAppFiles = Get-ChildItem -Path $path -Filter "*.app" -Recurse -exclude "*test*.app", "*library*.app" | Where-Object {@("\\test\\") -notcontains "$_.Name"}
$AllApps = @()

foreach ($AppFile in $AllAppFiles) {
    $App = Get-NAVAppInfo -Path $AppFile.FullName
    $AllApps += [PSCustomObject]@{
        id           = $App.id
        Version      = $App.version
        Name         = $App.name
        Publisher    = $App.publisher
        ProcessOrder = 0
        Dependencies = $App.dependencies
        Path         = $AppFile.FullName
    }
}

# Create a hashtable to store dependencies
$DependencyMap = @{}

foreach ($App in $AllApps) {
    foreach ($Dependency in $App.Dependencies) {
        if (-not $DependencyMap.ContainsKey($Dependency.Name)) {
            $DependencyMap[$Dependency.Name] = @()
        }
        $DependencyMap[$Dependency.Name] += $App.Name
    }
}

# Output the dependencies
foreach ($App in $AllApps) {
    if ($DependencyMap.ContainsKey($App.Name)) {
        Write-Output "App: $($App.Name)"
        Write-Output "  Is depended on by:"
        foreach ($DependentApp in $DependencyMap[$App.Name]) {
            Write-Output "    - $DependentApp"
        }
        Write-Output ""
    }
}